import 'package:flutter/material.dart';
import 'dart:async';
import 'dart:convert';
import 'dart:typed_data';

import 'package:flutter/services.dart';
import 'package:lailaolab_sunmi/lailaolab_sunmi.dart';

void main() {
  runApp(const MyApp());
}

class MyApp extends StatefulWidget {
  const MyApp({Key? key}) : super(key: key);

  @override
  State<MyApp> createState() => _MyAppState();
}

class _MyAppState extends State<MyApp> {
  String _platformVersion = 'Unknown';

  @override
  void initState() {
    super.initState();
    initPlatformState();
  }

  // Platform messages are asynchronous, so we initialize in an async method.
  Future<void> initPlatformState() async {
    String platformVersion;
    // Platform messages may fail, so we use a try/catch PlatformException.
    // We also handle the message potentially returning null.
    try {
      // platformVersion =
      //     await Hello.platformVersion ?? 'Unknown platform version';
      platformVersion = "0.0.2";
    } on PlatformException {
      platformVersion = 'Failed to get platform version.';
    }

    // If the widget was removed from the tree while the asynchronous platform
    // message was in flight, we want to discard the reply rather than calling
    // setState to update our non-existent appearance.
    if (!mounted) return;

    setState(() {
      _platformVersion = platformVersion;
    });
  }

  @override
  Widget build(BuildContext context) {
    return MaterialApp(
      home: Scaffold(
        appBar: AppBar(
          title: const Text('Plugin example app'),
        ),
        body: Column(
          mainAxisAlignment: MainAxisAlignment.center,
          crossAxisAlignment: CrossAxisAlignment.center,
          children: [
            Center(
              child: Text('Running on: $_platformVersion\n'),
            ),
            RaisedButton(
              onPressed: () async {
                print("GOOD JOB");
                final ByteData data = await NetworkAssetBundle(Uri.parse(
                        "http://restaurant.appzap.la/aa.png"))
                    .load("");
                final buffer = data.buffer;
                final imgData = base64.encode(Uint8List.view(buffer));
                SunmiPrinter.emptyLines(1);
                SunmiPrinter.image(imgData);
                SunmiPrinter.hr(); // prints a full width separator
                SunmiPrinter.emptyLines(1);
                SunmiPrinter.text(
                  'ເຝີເຮືອຊິ້ງ',
                  styles: SunmiStyles(align: SunmiAlign.center, size: SunmiSize.xl),
                );
                SunmiPrinter.emptyLines(1);
                SunmiPrinter.hr();

                SunmiPrinter.emptyLines(1);
                SunmiPrinter.text(
                  "ຈ່ອຍຫໍານ້ອຍ",
                  styles:
                      SunmiStyles(align: SunmiAlign.center, size: SunmiSize.sm),
                );
                SunmiPrinter.emptyLines(1);
                SunmiPrinter.row(
                  cols: [
                    SunmiCol(text: 'ຊື່ເມນູ123', width: 7),
                    SunmiCol(text: 'ເວລາ: 123123', width: 5),
                  ],
                );

                SunmiPrinter.emptyLines(5);
              },
              child: Text("ກົດໂລດ"),
            )
          ],
        ),
      ),
    );
  }
}
